stages:
  - build
  # - test
  - release

default:
  image: node:18

workflow:
  rules:
    - if: $CI_COMMIT_TITLE =~ /^Version release \d+\.\d+\.\d+$/
      when: never
    - if: $CI_COMMIT_BRANCH
      when: always
    - changes:
      - "*.md"
      - postman/*
      when: never
    - when: always

.version_template: &version_check
- node -v
- npm -v

variables:
  REPO_AUTH: https://$GIT_AUTH@gitlab.com/csiro-geoanalytics/npm/ngx-cool-dialogs.git

########  ##     ## #### ##       ########
##     ## ##     ##  ##  ##       ##     ##
##     ## ##     ##  ##  ##       ##     ##
########  ##     ##  ##  ##       ##     ##
##     ## ##     ##  ##  ##       ##     ##
##     ## ##     ##  ##  ##       ##     ##
########   #######  #### ######## ########

build:
  stage: build
  cache:
    paths:
      - node_modules/
  artifacts:
    paths:
      - dist/
  script:
    - *version_check
    - npm ci
    - npm run build:lib
    # Inject CI build info.
    - echo "Injecting CI build info."
    - export TIMESTAMP=$(date --utc +%FT%TZ)
    - export COMMIT_AUTHOR=$(git log -1 --pretty=format:%an ${CI_COMMIT_SHA})
    - >
      echo '{
      "build":'${CI_PIPELINE_IID}',
      "commit":"'${CI_COMMIT_SHA}'",
      "commitMessage":"'${CI_COMMIT_TITLE}'",
      "commitAuthor":"'${COMMIT_AUTHOR}'",
      "branch":"'${CI_COMMIT_REF_NAME}'",
      "jobId":'${CI_JOB_ID}',
      "pipeline":'${CI_PIPELINE_ID}',
      "timestamp":"'${TIMESTAMP}'"
      }' > ./dist/ng-lib/ci-build-info.json
    - cp ./README.md ./dist/ng-lib/README.md

######## ########  ######  ########
   ##    ##       ##    ##    ##
   ##    ##       ##          ##
   ##    ######    ######     ##
   ##    ##             ##    ##
   ##    ##       ##    ##    ##
   ##    ########  ######     ##

# lint:
#   stage: test
#   dependencies:
#     - build
#   script:
#     - npm run lint
#   except:
#     - tags

# test:
#   stage: test
#   dependencies:
#     - build
#   script:
#     - npm run test
#   except:
#     - tags

########  ######## ##       ########    ###     ######  ########
##     ## ##       ##       ##         ## ##   ##    ## ##
##     ## ##       ##       ##        ##   ##  ##       ##
########  ######   ##       ######   ##     ##  ######  ######
##   ##   ##       ##       ##       #########       ## ##
##    ##  ##       ##       ##       ##     ## ##    ## ##
##     ## ######## ######## ######## ##     ##  ######  ########

.release:
  stage: release
  dependencies:
    - build
  script:
    - git config --global user.email $GIT_EMAIL
    - git config --global user.name "GitLab CI"
    - git config remote.origin.url $REPO_AUTH
    - git checkout master
    - echo "//registry.npmjs.org/:_authToken=$NPM_TOKEN" > ~/.npmrc
    - npm ci
    - npm run version:lib --release=$RELEASE_TYPE
    - npm run publish:lib --release=$RELEASE_TYPE
  only:
    - master
  when: manual

release-patch:
  extends: .release
  variables:
    RELEASE_TYPE: patch

release-minor:
  extends: .release
  variables:
    RELEASE_TYPE: minor

release-major:
  extends: .release
  variables:
    RELEASE_TYPE: major
